
require("config")
require("framework.init")
require("framework.shortcodes")
require("framework.cc.init")
D_GATE = require("app.data.DGate")
D_FISH = require("app.data.DFish")

local MyApp = class("MyApp", cc.mvc.AppBase)

function MyApp:ctor()
    MyApp.super.ctor(self)
end

function MyApp:run()
    CCFileUtils:sharedFileUtils():addSearchPath("res/")
    display.addSpriteFramesWithFile(RES_INDEX_UI_FILE, RES_INDEX_UI_IMAGE)
    display.addSpriteFramesWithFile(RES_MAIN_UI_FILE, RES_MAIN_UI_IMAGE)
    display.addSpriteFramesWithFile(RES_FISH_UI_FILE, RES_FISH_UI_IMAGE)
    self:enterIndexScene()
    -- self:enterMainScene(1)
end

function MyApp:enterMainScene(sceneIndex)
    self:enterScene("MainScene", {sceneIndex}, "fade", 0.6, display.COLOR_WHITE)
end

function MyApp:enterIndexScene()
    self:enterScene("IndexScene", nil, "fade", 0.6, display.COLOR_WHITE)
end

function MyApp:enterMapScene()
    self:enterScene("MapScene", nil, "fade", 0.6, display.COLOR_WHITE)
end

function MyApp:enterSelectScene()
    self:enterScene("SelectScene", nil, "fade", 0.6, display.COLOR_WHITE)
end

function MyApp:enterShopScene()
    self:enterScene("ShopScene", nil, "fade", 0.6, display.COLOR_WHITE)
end

return MyApp
