local EnemyLayer = class("EnemyLayer", function()
    return display.newLayer()
end)

function EnemyLayer:ctor(player, sceneIndex, levelIndex)
    local allFishtTable = D_FISH.getFishTable(sceneIndex)

    -- 鱼所在层，该层可重复利用同一图片，不会造成额外的内存开销
    local fishLayer = display.newBatchNode(RES_FISH_UI_IMAGE)
    self:addChild(fishLayer)

    if sceneIndex == 1 then
        local canGenerateFish = true
        local curScore = 0
        local allScore = D_GATE.getTargetScore(sceneIndex, levelIndex)
        local targetGenerateScore = allScore/0.5
        local curFishNum = 1
        local fishTab = {}
        while canGenerateFish do

            local t = math.random(3)
            local tId = 1
            if t == 1 then
                tId = math.random(1, 3)
            elseif t == 2 then
                tId = math.random(4, 6)
            elseif t == 3 then
                tId = 7
            end

            local startPosX = display.right
            if math.random(1, 7) <= math.floor(7 * 0.5) then
                startPosX = display.left
            end

            -- 位置设为y为0是因为SFish里单独对其设置了位置
            fishTab[curFishNum] = require("app.sprite.SFish").new(sceneIndex, tId, ccp(startPosX, 0), player.hook)
            -- fishLayer:addChild(fish)
            curFishNum = curFishNum + 1

            curScore = curScore + D_FISH.getFishTable(sceneIndex)[tId].score

            if curScore >= targetGenerateScore then
                canGenerateFish = false
            end
        end

        -- 控制鱼每一秒只生成一个
        local gapTime = 0
        for i = 1, #fishTab do
            self:performWithDelay(function()
                fishLayer:addChild(fishTab[i])
            end, gapTime)
            gapTime = gapTime + 1
        end

        -- 单独生成河蚌，每关只有一个
        -- 位置设为ccp(0, 0)是因为SFish里单独对其设置了位置
        local fish = require("app.sprite.SFish").new(sceneIndex, 8, ccp(0, 0), player.hook)
        fishLayer:addChild(fish)
    else
        -- 第一批生成鱼类的比例
        local firstPrecent = {
            0.6,
            0.65,
            0.65,
        }
        -- 第一批生成鱼类的高中低分比值
        local firstRate = {
            1,
            3,
            2,
        }

        -- 第一批生成鱼类高中低分比值总数
        local firstTotal = 6
        -- 第二批生成鱼类的高中低分比值（根据每个场景不同而不同）
        local secondRate = {
            {2, 2, 1},
            {2, 2, 1},
            {3, 2, 2},
        }
        -- 第二批生成鱼类高中低分比值总数（根据每个场景不同而不同）
        local secondTotal = {
            5,
            5,
            7,
        }
        -- 用于对应上述的数组下标
        local tIndex = sceneIndex - 1

        -- 第一次生成鱼类
        local canGenerateFish = true
        -- 生成鱼的数量
        local curFishNum = 1
        local curScore = 0
        local allScore = D_GATE.getTargetScore(sceneIndex, levelIndex)
        local targetGenerateScore = allScore/0.5*firstPrecent[tIndex]
        local fishTab = {}
        while canGenerateFish do
            local t = math.random(firstTotal)
            local tId = 1
            if 1 <= t and t <= firstRate[1] then
                tId = math.random(1, 3)
            elseif firstRate[1] + 1 <= t and t <= firstRate[1] + firstRate[2] then
                tId = math.random(4, 6)
            elseif firstRate[1] + firstRate[2] + 1 <= t and t <= firstRate[1] + firstRate[2] + firstRate[3] then
                tId = math.random(7, 9)
            end

            local startPosX = display.right
            if math.random(1, 7) <= math.floor(7 * 0.5) then
                startPosX = display.left
            end

            -- 位置设为y为0是因为SFish里单独对其设置了位置
            fishTab[curFishNum] = require("app.sprite.SFish").new(sceneIndex, tId, ccp(startPosX, 0), player.hook)
            -- 鱼数量加1
            curFishNum = curFishNum + 1

            curScore = curScore + D_FISH.getFishTable(sceneIndex)[tId].score

            if curScore >= targetGenerateScore then
                canGenerateFish = false
            end
        end
        -- 控制鱼每一秒只生成一个
        local gapTime = 0
        local firstLengh = #fishTab
        for i = 1, firstLengh do
            self:performWithDelay(function()
                fishLayer:addChild(fishTab[i])
            end, gapTime)
            gapTime = gapTime + 1
        end

        -- 30秒后生成第二批鱼类
        self:performWithDelay(function()
            local canGenerateFishAgain = true
            targetGenerateScore = allScore/0.5
            while canGenerateFishAgain do

                local t = math.random(secondTotal[tIndex])
                local tId = 1
                if 1 <= t and t <= secondRate[tIndex][1] then
                    tId = math.random(1, 3)
                elseif secondRate[tIndex][1] + 1 <= t and t <= secondRate[tIndex][1] + secondRate[tIndex][2] then
                    tId = math.random(4, 6)
                elseif secondRate[tIndex][1] + secondRate[tIndex][2] + 1 <= t 
                    and t <= secondRate[tIndex][1] + secondRate[tIndex][2] + secondRate[tIndex][3] then
                    tId = math.random(7, 9)
                end

                local startPosX = display.right
                if math.random(1, 7) <= math.floor(7 * 0.5) then
                    startPosX = display.left
                end

                -- 位置设为y为0是因为SFish里单独对其设置了位置
                fishTab[curFishNum] = require("app.sprite.SFish").new(sceneIndex, tId, ccp(startPosX, 0), player.hook)
                -- 鱼数量加1
                curFishNum = curFishNum + 1

                curScore = curScore + D_FISH.getFishTable(sceneIndex)[tId].score

                if curScore >= targetGenerateScore then
                    canGenerateFishAgain = false
                end
            end

            -- 控制鱼每一秒只生成一个
            local gapTime = 0
            for i = firstLengh + 1, #fishTab do
                self:performWithDelay(function()
                    fishLayer:addChild(fishTab[i])
                end, gapTime)
                gapTime = gapTime + 1
            end
        end, 30)

        
        -- 第10秒生成第一条鲨鱼
        -- 第25秒生成第二条鲨鱼
        -- 第40秒生成第三条鲨鱼
        local tTime = 10
        for i = 1, 3 do
            self:performWithDelay(function()
                local startPosX = display.right
                if math.random(1, 7) <= math.floor(7 * 0.5) then
                    startPosX = display.left
                end
                -- 位置设为y为0是因为SFish里单独对其设置了位置
                local fish = require("app.sprite.SFish").new(sceneIndex, 10, ccp(startPosX, 0), player.hook)
                fishLayer:addChild(fish)
            end, tTime)
            tTime = tTime + 15
        end
    end

    -- 单独生成宝箱、钱袋（每一关都有）
    for i = #allFishtTable - 1, #allFishtTable do
        local fish = require("app.sprite.SFish").new(sceneIndex, i, ccp(display.right, 30 + math.random(display.cy)), player.hook)
        fishLayer:addChild(fish)
    end

    -- 随机生成泡泡
    local function onSchedule()
        if math.random() < 0.5 then
            local s = display.newSprite():addTo(self)
            s:setPosition(ccp(math.random(display.width), math.random(300)))
            local action1 = CCArray:create()
            action1:addObject(CCAnimate:create(CCAnimationCache:sharedAnimationCache():animationByName("bubble_anim")))
            action1:addObject(CCMoveTo:create(5, ccp(s:getPositionX(), 420)))
            action1:addObject(CCCallFunc:create(function ()
                s:removeSelf(true)
            end))
            s:runAction(CCSequence:create(action1))
            local t = math.random(10, 30)
            s:setScale(t*0.01)
        end
    end
    self:schedule(onSchedule, 3)
end

return EnemyLayer