--
-- Author: Yiqiong Shi
-- Date: 2013-11-29 14:57:03
--
local HelpDialog = class("HelpDialog", function()
    return display.newLayer()
end)

function HelpDialog:ctor()

	local content = display.newSprite("#help_bg.png", display.cx, display.cy):addTo(self)
	local w = content:getContentSize().width
	local h = content:getContentSize().height


	local back = ui.newImageMenuItem({image = "#map_back.png"
		, imageSelected = "#map_back_pressed.png"
		, sound         = GAME_SFX.button
		, listener = function ()        
			self:getParent().menu:setTouchEnabled(true)
			self:removeFromParentAndCleanup(true)
		end}):pos(w - 140, h -120)
	ui.newMenu({back}):addTo(content)
    
    local txt = "1. 当鱼钩对准水中的鱼后，点击\n    屏幕任意位置即可伸出钓钩捕\n    获（不小心钓到鲨鱼上船，会\n    导致游戏失败！）\n2. 每个场景共设20个关卡，全部\n    通关后即可解锁并进入下一个\n    场景\n3. 人物解锁：完成渤海场景会解\n    锁“熊大”，完成钓鱼岛场景\n    会解锁“光头强”\n4. 道具说明：购买道具后，点击\n    游戏界面的道具图标，即可使\n    用。\n    深水炸弹：炸死鲨鱼\n    汉堡包：提高20%的拉杆速度\n    ，可使用多个（限本局游戏）\n    延时器：延长每局游戏时间5\n    秒（限本局游戏）"
    local sH = 350
    local scrollView = CCScrollView:create()
    scrollView:setViewSize(CCSizeMake(w, sH))
    scrollView:setPosition(ccp(0, (h-sH)/2-25))
    
    scrollView:setScale(1.0) 
    scrollView:ignoreAnchorPointForPosition(true)
   
    local txtSprite = ui.newBMFontLabel({
            text  = txt, 
            x     = 0,
            y     = 0,
            align = ui.TEXT_ALIGN_LEFT,
            font  = TEXT_FNT})

    txtSprite:setPosition(ccp((w - txtSprite:getContentSize().width)/2
        , sH - txtSprite:getContentSize().height))
    scrollView:setContainer(txtSprite)
    scrollView:updateInset()
    scrollView:setDirection(kCCScrollViewDirectionVertical)
    scrollView:setClippingToBounds(true)
    scrollView:setBounceable(true)
    content:addChild(scrollView)
end

return HelpDialog