local PauseDialog = class("PauseDialog", function()
    return display.newLayer()
end)

function PauseDialog.onEnterOrExit(tag)
    if tag == "enter" then
        -- 游戏暂停
        display.pause()
    elseif tag == "exitTransitionStart" then
        -- 游戏恢复
        display.resume()
    end
end

function PauseDialog:ctor(sceneIndex)
    self:registerScriptHandler(self.onEnterOrExit)

    local content = display.newSprite("#dialog_bg.png"
        , display.cx
        , display.cy):addTo(self)

    local w = content:getContentSize().width
    local h = content:getContentSize().height
    
    local title = display.newSprite("#pause_title.png"
        , 0.5*w
        , 0.5*h + 145):addTo(content)

    local items = {}
    for i = 1, 3 do
        items[i] = ui.newImageMenuItem({
            image         = "#pause_b" .. i .. ".png",
            imageSelected = "#pause_b" .. i .. "_pressed.png",
            x             = w*0.5,
            y             = h*0.5 + 140 - 90*i,
            sound         = GAME_SFX.button,
            listener      = function()
                self:getParent().sub_menu:setTouchEnabled(true)
                if i == 1 then
                    self:removeSelf(true)
                elseif i == 2 then
                    app:enterMainScene(sceneIndex)
                elseif i == 3 then

                end
            end
        })
    end

    ui.newMenu(items):addTo(content)
end

return PauseDialog