--
-- Author: Yiqiong Shi
-- Date: 2013-11-25 11:57:10
--
local IndexScene = class("IndexScene", function()
    return display.newScene("IndexScene")
end)

function IndexScene:ctor()
    display.newSprite("#index_bg.jpg", display.cx, display.cy):addTo(self)

    local items = {}
    local g = 90
    for i = 1, 4 do 
        items[i] = ui.newImageMenuItem({image = "#index_button" .. i .. ".png"
            , imageSelected = "#index_button_pressed" .. i .. ".png"
            , sound         = GAME_SFX.button
            , listener = function ()
                if i == 1 then
                    app:enterMapScene()
                elseif i == 2 then
                    app:enterSelectScene()
                elseif i == 3 then
                    CCDirector:sharedDirector():pushScene(require("app.scenes.ShopScene").new())
                elseif i == 4 then
                    if device.platform == "android" then
                        local javaClassName = "mobi.shoumeng.smfishing.Smfishing"
                        local javaMethodName = "sendString"
                        local javaParams = {
                           "ad_list"
                        }
                        local javaMethodSig = "(Ljava/lang/String;)V"
                        luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
                    end
                end
            end
            }):pos(display.right-300, display.bottom + 260 +(2-i)*g+g*0.5)
    end

    items[5] = ui.newImageMenuItem({image = "#index_help.png"
        , imageSelected = "#index_help_pressed.png"
        , sound         = GAME_SFX.button
        , listener = function ()
            self.menu:setTouchEnabled(false)
            self:addChild(require("app.layers.HelpDialog").new(), 11)
        end}):pos(display.left + 150, display.height - 60)
    items[6] = ui.newImageMenuItem({image = "#index_feedback.png"
        , imageSelected = "#index_feedback_pressed.png"
        , sound         = GAME_SFX.button
        , listener = function ()
            if device.platform == "android" then
                local javaClassName = "mobi.shoumeng.smfishing.Smfishing"
                local javaMethodName = "sendString"
                local javaParams = {
                   "feed_back"
                }
                local javaMethodSig = "(Ljava/lang/String;)V"
                luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
            end
        end}):pos(display.left + 150 + 150, display.height - 60)

    self.menu = ui.newMenu(items):addTo(self)

    display.newSprite("#index_title.png", display.right-300, display.top - 100):addTo(self)
end

function IndexScene:onEnter()
    if device.platform == "android" then
        -- avoid unmeant back
        self:performWithDelay(function()
            -- keypad layer, for android
            local layer = display.newLayer()
            layer:addKeypadEventListener(function(event)
                if event == "back" then app.exit() end
            end)
            self:addChild(layer)

            layer:setKeypadEnabled(true)
        end, 0.5)
    end
end

function IndexScene:onExit()
end

return IndexScene
