--
-- Author: Yiqiong Shi
-- Date: 2013-11-25 14:33:24
--
local MapScene = class("MapScene", function()
    return display.newScene("MapScene")
end)

function MapScene:ctor()
    display.newSprite("map/map1.jpg", display.cx, display.cy):addTo(self)
    local contentBg = display.newSprite("#map_content.png", display.cx, display.cy)
    self:addChild(contentBg)
    display.newSprite("#map_title.png", display.cx, display.top - 80)
        :addTo(self)

    local w = contentBg:getContentSize().width
    local h = contentBg:getContentSize().height
    local items = {} 

    local points = { {x = 250, y = h-240}
                    , {x = 400, y = h-300}
                    , {x = 250, y = 200}
                    , {x = 660, y = 150} }
    
    local curEnable = CCUserDefault:sharedUserDefault():getIntegerForKey(KEY_SCENE_ENABLE_INDEX, 1)
    for i = 1 , 4 do                
        items[i] = ui.newImageMenuItem({image = "#place0.png"
            , imageSelected = "#place1.png"
            , imageDisabled = "#place2.png"
            , sound         = GAME_SFX.button
            , listener = function ()
                app:enterMainScene(i)
            end}):pos(points[i].x, points[i].y)

        if i > curEnable then
            items[i]:setEnabled(false)
        end
    end
    
    -- 按钮：返回
    items[5] = ui.newImageMenuItem({image = "#map_back.png"
        , imageSelected = "#map_back_pressed.png"
        , sound         = GAME_SFX.button
        , listener = function ()
            app:enterIndexScene()
        end}):pos(w-120, h-120)

    ui.newMenu(items):addTo(contentBg)

end

function MapScene:onEnter()
    -- 停止播放背景音乐
    audio.stopBackgroundMusic(false)
    
    if device.platform == "android" then
        -- avoid unmeant back
        self:performWithDelay(function()
            -- keypad layer, for android
            local layer = display.newLayer()
            layer:addKeypadEventListener(function(event)
                if event == "back" then app:enterIndexScene() end
            end)
            self:addChild(layer)

            layer:setKeypadEnabled(true)
        end, 0.5)
    end
end

function MapScene:onExit()
end

return MapScene