--
-- Author: Yiqiong Shi
-- Date: 2013-11-25 14:32:03
--
local SelectScene = class("SelectScene", function()
    return display.newScene("SelectScene")
end)

function SelectScene:ctor()
    self.id = CCUserDefault:sharedUserDefault():getIntegerForKey(KEY_PLAYER_ID, 1)

    display.newSprite("img/select_bg.jpg", display.cx, display.cy):addTo(self)

    local title = display.newSprite("#select_title.png"
        , display.cx, display.top-80):addTo(self)

    local yes = display.newSprite("#select_yes.png"
        , display.cx, display.cy):addTo(self, 1)
    
    local items = {}
    local headW = 300 + (display.width - 960)/3

    local curEnable =  CCUserDefault:sharedUserDefault():getIntegerForKey(KEY_PLAYER_ENABLE_INDEX, 1)
    for i = 1, 3 do
        items[i] = ui.newImageMenuItem({image = "#head" .. i .. ".png"
            , imageDisabled = "#head" .. i .. "_disable.png"
            , sound         = GAME_SFX.button
            , listener = function ( )
                self.id = i
                yes:setScale(0)
                yes:runAction(CCScaleTo:create(0.2, 1))
                yes:setPosition(ccp(items[i]:getPositionX()+100, items[i]:getPositionY()+100))
            end}):pos(display.cx+(i-2)*headW, display.cy-20)

        if i > curEnable then
            items[i]:setEnabled(false)
        end
    end

    yes:setPosition(ccp(items[self.id]:getPositionX()+100, items[self.id]:getPositionY()+100))

    items[4] = ui.newImageMenuItem({ image = "#back.png"
        , imageSelected = "#back_pressed.png"
        , sound         = GAME_SFX.button
        , listener = function ()
            app:enterIndexScene()
        end}):pos(display.left + 80, display.top - 70)

    items[5] = ui.newImageMenuItem({ image = "#select_start.png"
        , imageSelected = "#select_start_pressed.png"
        , sound         = GAME_SFX.button
        , listener = function ()
            app:enterMapScene()
        end}):pos(display.cx, display.bottom + 70)

    local menu = ui.newMenu(items)
    self:addChild(menu)
end

function SelectScene:onEnter()
    if device.platform == "android" then
        -- avoid unmeant back
        self:performWithDelay(function()
            -- keypad layer, for android
            local layer = display.newLayer()
            layer:addKeypadEventListener(function(event)
                if event == "back" then app:enterIndexScene() end
            end)
            self:addChild(layer)

            layer:setKeypadEnabled(true)
        end, 0.5)
    end
end

function SelectScene:onExit()
    CCUserDefault:sharedUserDefault():setIntegerForKey(KEY_PLAYER_ID, self.id)
    CCUserDefault:sharedUserDefault():flush()
end

return SelectScene