local ShopScene = class("ShopScene", function()
    return display.newScene("ShopScene")
end)

function ShopScene:ctor()
    -- 用来做显示的数字
    local goldNum = CCUserDefault:sharedUserDefault():getIntegerForKey(KEY_TOTAL_GOLD_NUMBER, 0)
    -- 用来做存储（点击了购买之后）的数字
    local tGoldNum = goldNum
    -- 点击需要购买的数量
    local addNum = {0, 0, 0}

    display.newSprite("img/select_bg.jpg", display.cx, display.cy):addTo(self)
    local content = display.newSprite("#bg_shop.png", display.cx, display.cy):addTo(self)

    local h = content:getContentSize().height

    local items = {}
    local numGold = {}
    -- 商品图标
    local tabPicName = {
        "#pic_boom.png",
        "#pic_hamburger.png",
        "#pic_time.png",
    }
    -- 商品名
    local tabTxtTitle = {
        "深水炸弹",
        "汉堡包",
        "延时器",
    }
    -- 商品描述
    local tabTxtContent = {
        "不小心钓到鲨鱼时，用深水炸\n弹轰掉它吧!",
        "补充能量，可以提高拉钩速度\n20%。",
        "可以延长关卡时间5秒，每个\n关卡限使用1次。",
    }
    -- 商品价格的文字信息
    local tabTxtGold = {
        "10元宝",
        "30元宝",
        "50元宝",
    }
    -- 商品价格
    local tabGapGold = {
        10,
        30,
        50,
    }

    -- 分别将炸弹、汉堡包、时间三个项添加到该对话框
    for i = 1, 3 do
        -- 每一个商品的价格
        local gapGold = tabGapGold[i]

        -- 每一项的基准线
        local stdPosX = 215
        local stdPosY = h*0.5 - i*130 + 200

        -- 图片：商品图标
        display.newSprite(tabPicName[i], stdPosX, stdPosY):addTo(content)
        -- 文字：商品标题
        local tTitle = ui.newBMFontLabel({
            text  = tostring(tabTxtTitle[i]), 
            x     = stdPosX + 150,
            y     = stdPosY + 40,
            align = ui.TEXT_ALIGN_CENTER,
            font  = TEXT_FNT}):addTo(content)
        tTitle:setScale(0.5)
        -- 文字：商品内容
        local tContent = ui.newBMFontLabel({
            text  = tostring(tabTxtContent[i]), 
            x     = stdPosX + 50,
            y     = stdPosY,
            align = ui.TEXT_ALIGN_LEFT,
            font  = TEXT_FNT}):addTo(content)
        tContent:setScale(0.4)
        -- 文字：商品价格
        local tGold = ui.newBMFontLabel({
            text  = tostring(tabTxtGold[i]), 
            x     = stdPosX + 280,
            y     = stdPosY + 13,
            align = ui.TEXT_ALIGN_LEFT,
            font  = TEXT_FNT}):addTo(content)
        tGold:setColor(ccc3(0, 0, 0))
        tGold:setScale(0.6)

        -- 按钮：从第一个减号到第三个减号
        items[i] = ui.newImageMenuItem({
            image         = "#btn_minus.png",
            imageSelected = "#btn_minus.png",
            x             = stdPosX + 480 - 90,
            y             = stdPosY + 20 - 5,
            sound         = GAME_SFX.button,
            listener      = function()
                local curNumGold = toint(numGold[i]:getString())
                if curNumGold == 0 then
                    curNumGold = 0
                else
                    curNumGold = curNumGold - gapGold
                    addNum[i] = addNum[i] - 1
                    local t = goldNum + gapGold
                    goldNum = t
                    self.totalGoldNum:setString(tostring(goldNum))
                end
                numGold[i]:setString(tostring(addNum[i]))
            end
        })
        -- 图片：从第一个金币数的背景到第三个金币数的背景
        local costGoldBg = display.newSprite("#bg_number.png", stdPosX + 435, stdPosY + 13):addTo(content)
        -- 数字：从第一个花的金币数到第三个花的金币数
        numGold[i] = ui.newBMFontLabel({
            text  = "0", 
            x     = costGoldBg:getContentSize().width*0.5,
            y     = costGoldBg:getContentSize().height*0.5,
            align = ui.TEXT_ALIGN_CENTER,
            font  = TEXT_FNT}):addTo(costGoldBg)
        numGold[i]:setScale(0.6)
        numGold[i]:setColor(ccc3(0, 0, 0))

        -- 按钮：从第一个加号到第三个加号
        items[3 + i] = ui.newImageMenuItem({
            image         = "#btn_plus.png",
            imageSelected = "#btn_plus.png",
            x             = stdPosX + 570 - 90,
            y             = stdPosY + 20 - 5,
            sound         = GAME_SFX.button,
            listener      = function()
                local t = goldNum - gapGold
                if t >= 0 then
                    local curNumGold = toint(numGold[i]:getString())
                    curNumGold = curNumGold + gapGold
                    addNum[i] = addNum[i] + 1
                    goldNum = t
                    numGold[i]:setString(tostring(addNum[i]))
                    self.totalGoldNum:setString(tostring(goldNum))
                end
            end
        })
        
        -- 按钮：从第一个购买按钮到第三个购买按钮
        items[3 + 3 + i] = ui.newImageMenuItem({
            image         = "#btn_buy.png",
            imageSelected = "#btn_buy_pressed.png",
            x             = stdPosX + 650 - 90,
            y             = stdPosY + 20 - 5,
            sound         = GAME_SFX.button,
            listener      = function()
                local curNum = CCUserDefault:sharedUserDefault():getIntegerForKey(tostring(KEY_TOOL_D .. i), 1)
                CCUserDefault:sharedUserDefault():setIntegerForKey(tostring(KEY_TOOL_D .. i), curNum + addNum[i])
                tGoldNum = tGoldNum - gapGold*addNum[i]
                CCUserDefault:sharedUserDefault():setIntegerForKey(KEY_TOTAL_GOLD_NUMBER, tGoldNum)    
                CCUserDefault:sharedUserDefault():flush()

                addNum[i] = 0
                numGold[i]:setString(tostring(addNum[i]))
            end
        })
    end

    -- 下方我的元宝的信息
    -- 图片：元宝图
    display.newSprite("#pic_gold.png", 550 - 30, 60):addTo(content)
    -- 文字：我的元宝
    local txtMyGold = ui.newBMFontLabel({
        text  = "我的元宝:          个", 
        x     = 550,
        y     = 60,
        align = ui.TEXT_ALIGN_LEFT,
        font  = TEXT_FNT}):addTo(content)
    txtMyGold:setScale(0.6)
    txtMyGold:setColor(ccc3(0, 0, 0))
    -- 文字：我的元宝数
    self.totalGoldNum = ui.newBMFontLabel({
        text  = tostring(CCUserDefault:sharedUserDefault():getIntegerForKey(KEY_TOTAL_GOLD_NUMBER, 0)), 
        x     = 550 + 110,
        y     = 60,
        align = ui.TEXT_ALIGN_LEFT,
        font  = TEXT_FNT}):addTo(content)
    self.totalGoldNum:setScale(0.7)
    self.totalGoldNum:setColor(ccc3(0, 0, 0))
    -- 按钮：返回
    items[#items + 1] = ui.newImageMenuItem({ image = "#back.png"
        , imageSelected = "#back_pressed.png"
        , sound         = GAME_SFX.button
        , listener      = function ()
            CCDirector:sharedDirector():popScene()
        end}):pos(display.left + 40, display.bottom + 80)

    ui.newMenu(items):addTo(content)
end

function ShopScene:onEnter()
    if device.platform == "android" then
        -- avoid unmeant back
        self:performWithDelay(function()
            -- keypad layer, for android
            local layer = display.newLayer()
            layer:addKeypadEventListener(function(event)
                if event == "back" then 
                    CCDirector:sharedDirector():popScene()
                end
            end)
            self:addChild(layer)

            layer:setKeypadEnabled(true)
        end, 0.5)
    end
end

return ShopScene