--
-- Author: Yiqiong Shi
-- Date: 2013-12-04 10:04:27
--
local SFish = class("SFish", function()
    return display.newSprite()
end)

function SFish:ctor(sceneIndex, listId, pos, hook)
	self.listId = listId
	self.hook = hook
	self:setPosition(pos)
	self.realId = D_FISH.getFishTable(sceneIndex)[self.listId].id
	self.score = D_FISH.getFishTable(sceneIndex)[self.listId].score
	self:setDisplayFrame(CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("fish_1_1.png"))
    self:run()

    local function onInterval(dt)
    	if self.hook.state == 1 
    		and self:boundingBox():intersectsRect(self.hook:boundingBox()) then 
    		self:unscheduleUpdate()
    		self.hook:getFish(self.realId, self.score)
    		self:removeFromParentAndCleanup(true)
    	end
    end
    self:scheduleUpdate(onInterval)
end

function SFish:run( )
	self:runAction(CCRepeatForever:create(CCAnimate:create(
		CCAnimationCache:sharedAnimationCache():animationByName("f" .. self.realId))))

	-- 选择是否做位移
	if self.realId < 19 then
		if 1 <= self.listId and self.listId <= 3 then
			self:setPosition(self:getPositionX(), math.random(150 - math.random(50), 350 - math.random(40)))
		elseif 4 <= self.listId and self.listId <= 6 then
			self:setPosition(self:getPositionX(), math.random(50 - math.random(30), 150 + math.random(50)))
		elseif 7 <= self.listId and self.listId <= 9 then
			self:setPosition(self:getPositionX(), math.random(5, 50 + math.random(100)))
		end
		local x1 = display.right
		local x2 = display.left
		local fX = false
		if self:getPositionX() == display.right then 
			x1 = display.left
			x2 = display.right
			fX = true
		end
		local t = self.realId + math.random(800)*0.01
		while t < 4 do t = t + 1 end

		-- 鲨鱼加速
		if self.listId == 10 then
			t = t * 0.7
		end
		-- 鲨鱼的位置
		if self.listId == 10 then
			self:setPosition(self:getPositionX(), math.random(20, 160))
		end
		
		local actions = CCArray:create()

		actions:addObject(CCFlipX:create(fX))
		actions:addObject(CCMoveTo:create(t, ccp(x1, self:getPositionY())))
	    actions:addObject(CCCallFunc:create(function()
	        if self.listId == 10 then
	        	self:stopAllActions()
	        	self:removeSelf(true)
	        end
	    end))
		actions:addObject(CCFlipX:create(not fX))
		actions:addObject(CCMoveTo:create(t, ccp(x2, self:getPositionY())))

		self:runAction(CCRepeatForever:create(
			CCSequence:create(actions)))
	elseif self.realId == 19 then
		-- 设置河蚌的位置
		self:setPosition(display.cx + math.random(-0.5*display.width, 0.5*display.width), math.random(60, 180))
	elseif self.realId == 20 or self.realId == 21 then
		self:setPosition(display.cx + math.random(-0.5*display.width, 0.5*display.width), self:getPositionY())
	end
end

return SFish